#include "widget.h"

#include <QGridLayout>
#include <QPushButton>
#include <QDialog>
#include <QTimer>
#include <QDebug>

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    popup(nullptr)
{
    resize(400, 300);
    QPushButton *pushButton = new QPushButton("Show popup", this);
    pushButton->setGeometry(QRect(120, 120, 131, 61));
    connect(pushButton, &QPushButton::clicked, this, &Widget::showPopup);
}

Widget::~Widget()
{
}

void Widget::showPopup()
{
    if (!popup)
        popup = new QWidget(this, Qt::Popup);
    popup->move(pos());
    QGridLayout *grid = new QGridLayout(popup);
    QPushButton *button = new QPushButton("Show dialog", this);
    connect(button, &QPushButton::clicked, this, &Widget::showDialog);
    grid->addWidget(button);
    popup->show();
}

void Widget::showDialog()
{
    delete popup;
    popup = nullptr;

    QDialog dialog(this);
    QPushButton *button = new QPushButton("OK", &dialog);
    connect(button, &QPushButton::clicked, &dialog, &QDialog::accept);
    dialog.exec();
}
